#include<bits/stdc++.h>
using namespace std;
const int MAXN=2e4+6;
const int lg=16;
const int MAXA=1e3+6;
int without[MAXN];
int nr[MAXN],nl[MAXN];
int dpl[MAXN],dpr[MAXN];
int dpparl[MAXN][lg];
int dpparr[MAXN][lg];
int bestdpl[MAXN][lg],n;
int bestdpr[MAXN][lg];
int fen[MAXA];
void update(int idx,int val)
{
    idx++;
    for(;idx<MAXN;idx+=idx&(-idx))
    {
        fen[idx]=max(fen[idx],val);
    }
}
int query(int idx)
{
    idx++;
    int ret=0;
    for(;idx>0;idx-=idx&(-idx))
    {
        ret=max(ret,fen[idx]);
    }
    return ret;
}
bool used[MAXA];
int best1[MAXA];
int a[MAXN];
int smallestl[MAXN][lg],biggestr[MAXN][lg];
void init(vector<int> prices)
{
    n=prices.size();
    reverse(prices.begin(),prices.end());
    prices.push_back(0);
    reverse(prices.begin(),prices.end());
    stack<pair<int,int> >st;
    for(int i=1;i<prices.size();i++)
    {
        a[i]=prices[i];
        while(!st.empty()&&st.top().first<=prices[i])st.pop();
        if(!st.empty())nl[i]=st.top().second;
        else nl[i]=0;
        st.push({prices[i],i});
    }
    while(!st.empty())st.pop();
    for(int i=prices.size()-1;i>1;i--)
    {
        while(!st.empty()&&st.top().first>=prices[i])st.pop();
        if(!st.empty())nr[i]=st.top().second;
        else nr[i]=0;
        st.push({prices[i],i});
    }
    for(int i=1;i<=n;i++)
    {
        dpl[i]=query(prices[i])+1;
        update(prices[i],dpl[i]);
    }
    memset(fen,0,sizeof(fen));
    for(int i=n;i>=1;i--)
    {
        dpr[i]=query(MAXA-prices[i])+1;
        update(MAXA-prices[i],dpr[i]);
    }
    for(int i=1;i<=n;i++)
    {
        dpparl[i][0]=nl[i];
        dpparr[i][0]=nr[i];
        bestdpl[i][0]=max(dpl[i],dpl[nl[i]]);
        bestdpr[i][0]=max(dpr[i],dpr[nr[i]]);
    }
    for(int step=1;step<lg;step++)
    {
        for(int i=1;i<=n;i++)
        {
            dpparl[i][step]=dpparl[dpparl[i][step-1]][step-1];
            dpparr[i][step]=dpparr[dpparr[i][step-1]][step-1];
            bestdpl[i][step]=max(bestdpl[i][step-1],bestdpl[dpparl[i][step-1]][step-1]);
            bestdpr[i][step]=max(bestdpr[i][step-1],bestdpr[dpparr[i][step-1]][step-1]);
        }
    }
    for(int i=1;i<=n;i++)
    {
        //without[i]
        int u;
        vector<pair<int,int> >dpl1,dpr1;
        /*
        u=i-1;
        while(u!=0)
        {
            dpl1.push_back({prices[u],dpl[u]});
            u=nl[u];
        }
        u=i+1;
        while(u!=0&&u<=n)
        {
            dpr1.push_back({prices[u],dpr[u]});
            u=nr[u];
        }*/
        memset(best1,0,sizeof(best1));
        for(int j=i+1;j<=n;j++)
        {
            best1[prices[j]]=max(best1[prices[j]],dpr[j]);
        }
        for(int j=MAXA-1;j>=1;j--)best1[j]=max(best1[j],best1[j+1]);
        without[i]=best1[1];
        for(int j=i-1;j>=1;j--)
        {
            without[i]=max(without[i],dpl[j]+best1[prices[j]]);
        }
    }
    for(int i=1;i<=n;i++)
    {
        biggestr[i][0]=prices[i];
        smallestl[i][0]=prices[i];
    }
    for(int step=1;step<lg;step++)
    {
        for(int i=1;i<=n;i++)
        {
            smallestl[i][step]=min(smallestl[i][step-1],smallestl[max(0,i-(1<<(step-1)))][step-1]);
            biggestr[i][step]=max(biggestr[i][step-1],biggestr[min(MAXN-1,i+(1<<(step-1)))][step-1]);
        }
    }
    //for(int i=1;i<=n;i++)cout<<without[i]<<" ";
    //cout<<endl;
}
int assumption(int day,int price)
{
    int bestl=0,bestr=0;
    int ret=without[day];
    int u=day-1;
    for(int j=lg-1;j>=0;j--)
    {
        if((1>>j)>u)continue;
        if(smallestl[u][j]>price)
        {
            u-=(1<<j);
        }
    }
   // cout<<u<<endl;
    bestl=dpl[u];
    for(int j=lg-1;j>=0;j--)
    {
        if(u==0)break;
        if(dpparl[u][j]==0)continue;
        if(a[dpparl[u][j]]>price)continue;
        bestl=max(bestl,bestdpl[u][j]);
        u=dpparl[u][j];
    }
    //cout<<"^^ "<<u<<endl;
    u=day+1;
    for(int j=lg-1;j>=0;j--)
    {
        if(u==0||u>n)continue;
        if(u+(1<<j)>n+1)continue;
        if(biggestr[u][j]<price)
        {
            u+=(1<<j);
        }
    }
    //cout<<u<<endl;
    bestr=dpr[u];
    for(int j=lg-1;j>=0;j--)
    {
        if(u==0||u>n)break;
        if(dpparr[u][j]==0)continue;
        if(a[dpparr[u][j]]<price)continue;
        bestr=max(bestr,bestdpr[u][j]);
        u=dpparr[u][j];
    }
    //cout<<"^^ "<<u<<endl;
    //cout<<bestl<<" "<<bestr<<endl;
    return max(ret,bestl+bestr+1);
}