#include<bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")
using namespace std;
const int MAXN=1e4+6;
const int MAXM=1e5+6;
int n,m;
int u[MAXM],v[MAXM];
set<int>active;
set<int>not_active;
vector<int>toggles[MAXM];
struct dsu
{
    int par[MAXN];
    int sz[MAXN],cntcomp;
    struct save
    {
        int p,q,parp,parq,szp,szq;
    };
    stack<save>st;
    void rollback()
    {
        save xd=st.top();st.pop();
        if(xd.p!=xd.q)++cntcomp;
        par[xd.p]=xd.parp;
        par[xd.q]=xd.parq;
        sz[xd.p]=xd.szp;
        sz[xd.q]=xd.szq;
    }
    void init()
    {
        for(int i=1;i<MAXN;++i)
        {
            par[i]=i;
            sz[i]=1;
        }
        cntcomp=n;
    }
    int getRoot(int u)
    {
        if(u==par[u])return u;
        return getRoot(par[u]);
    }
    void join(int p,int q)
    {
        st.push({p,q,par[p],par[q],sz[p],sz[q]});
        if(p==q)return;
        --cntcomp;
        if(sz[q]>sz[p])swap(p,q);
        par[q]=p;
        sz[p]+=sz[q];
    }
}ivan;
vector<int>tree[4*MAXM];
int ans[MAXM];
void add_edge(int idx,int l,int r,int ql,int qr,int which)
{
    if(r<ql||l>qr)return;
    if(l>=ql&&r<=qr)
    {
        tree[idx].push_back(which);
        return;
    }
    int mid=(l+r)/2;
    add_edge(idx*2,l,mid,ql,qr,which);
    add_edge(idx*2+1,mid+1,r,ql,qr,which);
}
void dfs(int idx,int l,int r)
{
    for(int i=0;i<tree[idx].size();++i)
    {
        ivan.join(ivan.getRoot(u[tree[idx][i]),ivan.getRoot(v[tree[idx][i]));
    }
    if(l==r)
    {
        ans[l]=ivan.cntcomp;
    }
    else
    {
        int mid=(l+r)/2;
        dfs(idx*2,l,mid);
        dfs(idx*2+1,mid+1,r);
    }
    for(int i=0;i<tree[idx].size();++i)ivan.rollback();
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>m;
    for(int i=1;i<=m;++i)cin>>u[i]>>v[i];
    for(int i=1;i<=m;++i)
    {
        toggles[i].push_back(1);
    }
    for(int i=1;i<n;++i)
    {
        int t;
        cin>>t;
        toggles[t].pop_back();
    }
    int q;
    cin>>q;
    for(int i=1;i<=q;++i)
    {
        int x,y;
        cin>>x>>y;
        toggles[x].push_back(i+1);
        toggles[y].push_back(i+1);
        //cout<<query()<<endl;
    }
    for(int i=1;i<=m;++i)
    {
        if(toggles[i].size()%2==1)toggles[i].push_back(q+2);
        for(int j=1;j<toggles[i].size();j+=2)
        {
            int l1=toggles[i][j-1];
            int r1=toggles[i][j]-1;
            //cout<<i<<" "<<l1<<" "<<r1<<endl;
            add_edge(1,1,q+3,l1,r1,i);
        }
    }
    ivan.init();
    dfs(1,1,q+3);
    for(int i=1;i<=q+1;++i)
    {
        cout<<n-ans[i]<<"\n";
    }
return 0;
}
/*
5 8
1 2
1 3
1 4
2 3
2 4
3 4
3 5
4 5
1 2 6 7
2
3 6
8 3
*/
