#include <iostream>
#include <vector>
#include <limits>
#include <cstring>
using namespace std;

vector<int> p;

void init (vector <int> prices) {
	p = prices;
}

int assumption (int day, int price) {
	--day;
	int ans = 0;
	int not_used = p.size();
	bool used[p.size()];
	memset(used, 0, sizeof(used));

	int old_price = p[day];
	p[day] = price;

	while(not_used > 0) {
		++ans;
		int curr = numeric_limits<int>::max();
		for(int i = 0; i < p.size(); ++i) {
			if(!used[i] && curr > p[i]) {
				curr = p[i];
				used[i] = true;
				--not_used;
			}
		}
	}

	p[day] = old_price;
	return ans;
}  