#include<bits/stdc++.h>
using namespace std;

const int nmax=1e5+42;

int n,m;

pair<int,int> inp[nmax];

bool block[nmax];
/*
int root(int node)
{
    if(parent[node]==node)return node;
    parent[node]=root(parent[node]);
    return parent[node];
}
int solve()
{
    for(int i=1;i<=n;i++)parent[i]=i;

    int outp=0;

    for(int i=1;i<=m;i++)
        if(block[i]==0)
        {
            int u=inp[i].first;
            int v=inp[i].second;

            if(root(u)!=root(v))outp++;

            parent[root(u)]=root(v);
        }

    return outp;
}
*/
int when[nmax];

vector< pair<int,int> > updates[nmax*4];

int components;
int outp[nmax];

int parent[nmax],SZ[nmax];

int comp[nmax];

int root(int node)
{
    while(node!=parent[node])node=parent[node];

    return node;
}
void solve(int node,int l,int r)
{
    vector< pair<int,int> > mem={};

    for(auto w:updates[node])
    {
        int u=root(w.first);
        int v=root(w.second);

        if(SZ[u]<SZ[v])swap(u,v);

        //SZ[u]>=SZ[v]
        if(u!=v)
        {
            components++;

            SZ[u]+=SZ[v];
            parent[v]=u;

            mem.push_back({u,v});
        }
    }

    if(l==r)outp[l]=components;
    else
    {
        int av=(l+r)/2;

        solve(node*2,l,av);

        solve(node*2+1,av+1,r);
    }

    reverse(mem.begin(),mem.end());

    for(auto w:mem)
    {
        int u=w.first;
        int v=w.second;

        components--;

        SZ[u]=SZ[u]-SZ[v];
        parent[v]=v;
    }
}

void update(int node,int l,int r,int lq,int rq,pair<int,int> edge)
{
    if(l==lq&&r==rq)
    {
        updates[node].push_back(edge);
        return;
    }

    int av=(l+r)/2;

    if(lq<=av)update(node*2,l,av,lq,min(av,rq),edge);
    if(av<rq)update(node*2+1,av+1,r,max(av+1,lq),rq,edge);
}
int main()
{
    scanf("%i%i",&n,&m);

    for(int i=1;i<=m;i++)
        scanf("%i%i",&inp[i].first,&inp[i].second);

    for(int i=1;i<=n;i++)parent[i]=i,SZ[i]=1;

    for(int i=1;i<=n-1;i++)
    {
        int cur;
        scanf("%i",&cur);

        block[cur]=1;
    }

    int q;
    scanf("%i",&q);

    for(int i=1;i<=q;i++)
    {
        int u,v;

        scanf("%i%i",&u,&v);

        update(1,0,q,when[u],i-1,inp[u]);
        when[v]=i;

        block[u]=1;
        block[v]=0;
    }

    for(int i=1;i<=m;i++)
        if(block[i]==0)update(1,0,q,when[i],q,inp[i]);

    solve(1,0,q);

    for(int i=0;i<=q;i++)
        printf("%i\n",outp[i]);

    return 0;
}