#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 200005;

int n, m;
int p[MAXN];
vector<int> g[MAXN], s[MAXN];
int L, R;

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    for (int i = 2; i <= n; ++ i)
    {
        int pi;
        cin >> pi;
        p[i] = pi;
        g[pi].push_back(i);
    }
    cin >> m;
    for (int j = 1; j <= m; ++ j)
    {
        int uj, kj;
        cin >> uj >> kj;
        s[uj].push_back(kj);
    }
}

vector<int> DFS(int u = 1)
{
    vector<int> res;
    for (int v : g[u])
    {
        vector<int> tmp = DFS(v);
        if (res.size() < tmp.size()) swap(res, tmp);
        {
            for (int i = 0; i < min(res.size(), tmp.size()); ++ i)
            {
                int v1 = res[res.size() - 1 - i];
                int v2 = tmp[tmp.size() - 1 - i];
                if (v1 >= L and v2 >= L) res[res.size() - 1 - i] = min(v1, v2);
                else if (v1 >= L) res[res.size() - 1 - i] = v1;
                else res[res.size() - 1 - i] = v2;
            }
        }
    }
    res.push_back(u);

    if (R == -1) return {};

    /*cout << "za vruh " << u << endl;
    for (int i = 0; i < res.size(); ++ i)
    {
        cout << res[i] << ' ' ;
    }
    cout << endl;*/

    for (int i = 0; i < s[u].size(); ++ i)
    {
        if (res[res.size() - 1 - s[u][i]] < L) {R = -1; return {};}
        else R = max(R, res[res.size() - 1 - s[u][i]]);
    }

    return res;
}

int main()
{
    Init();

    int optL = 0, optR = n + 1;
    for (int i = 1; i <= n; ++ i)
    {
        L = i;
        R = 0;
        DFS();

        if (R == -1) break;
        if ((R - L) < (optR - optL))
        {
            optL = L;
            optR = R;
        }
    }

    cout << optL << ' ' << optR << endl;
    return 0;
}

