#include<cstdio>
#include<queue>
#include<vector>
using namespace std;
#define MAXN 200000
struct minimax
{ int min,max; };
vector<int> G[MAXN];
int p[MAXN];
int n;
int m;
void init()
{
    scanf("%d",&n);
    for(int i=2;i<=n;i++)
        scanf("%d",p+i);
    scanf("%d",&m);
}
void init_plus()
{
	for(int i=2;i<=n;i++)
		G[p[i]].push_back(i);
}
minimax dfs_res;
void dfs(int v,int l)
{
	if(l==0)
	{
		if(dfs_res.min>l)dfs_res.min=v;
		if(dfs_res.max<l)dfs_res.max=v;
		return;
	}
	for(int i=0;i<G[v].size();i++)
		dfs(G[v][i],l-1);
}
int main()
{
	init();
	init_plus();
	int u,k;
	minimax res;
	int L=1000000,R=-1;
	for(int i=0;i<m;i++)
	{
		scanf("%d %d",&u,&k);
		dfs_res={10000000,-1};
		dfs(u,k);
		if(L>dfs_res.min)L=dfs_res.min;
		if(R<dfs_res.max)R=dfs_res.max;
	}
	printf("%d %d",L,R);
	return 0;
}