#include<bits/stdc++.h>
#define pb push_back
#define eb emplace_back
#define f first
#define s second
#define sz(x) ((int)x.size())
#define all(x) (x.begin(), x.end())

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

using ll = long long;
using ull = unsigned long long;
using namespace std;

const int MAXN = 2e5;
const int MAXM = 2e5;
int n, m;
vector<int> ch[MAXN];
int par[MAXN];
list<int> revqu[MAXN];
int l, r;

vector<vector<int>> un;
int h[MAXN];

void input() {
    cin>>n;
    for (int i=0; i<n-1; i++) {
        cin>>par[i];
        par[i]--;
        ch[par[i]].pb(i+1);
    }

    int a, b;
    cin>>m;
    for (int i=0; i<m; i++) {
        cin>>a>>b;
        revqu[a-1].pb(b);
    }
}

void output() {
    cout<<l+1<<' '<<r+1<<endl;
}

void dfs2(int curr, int depth) {
    if (h[depth] != -1) {
        un[h[depth]].pb(curr);
    }
    for (auto to : ch[curr]) {
        dfs2(to, depth + 1);
    }
}

int calcRight(int curr) {
    int cr = 0;
    for (int i=0; i<un.size(); i++) {
        auto id = lower_bound(un[i].begin(), un[i].end(), curr);
        if (id == un[i].end()) {
            return MAXN;
        }
        cr = max(cr, (*id));
    }
    return cr;
}

void solve() {
    for (int i=0; i<n; i++) {
        h[i] = -1;
    }
    for (int i=0; i<n; i++) {
        for (auto wh : revqu[i]) {
            h[wh] = un.size();
            un.eb();
        }
        dfs2(i, 0);
        for (auto wh : revqu[i]) {
            h[wh] = -1;
        }
    }

    int dlim = n;
    for (int i=0; i<un.size(); i++) {
        if (un[i].size() == 0) {
            continue;
        }
        int cmx = un[i][0];
        for (auto to : un[i]) {
            //cerr<<to<<' ';
            cmx = max(cmx, to);
        }
        //cerr<<endl;
        dlim = min(dlim, cmx);
    }

    l = 0, r = n;
    for (int j = 0; j <= dlim; j++) {
        int cr = calcRight(j);
        if (cr == -1) {
            break;
        }
        if (cr - j < r - l) {
            l = j;
            r = cr;
        }
    }
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    input();
    solve();
    output();
    return 0;
}

/*
7
1 1 2 2 3 3
3
1 1
3 1
1 2

6
1 2 3 4 5
2
1 1
3 2

*/
