#include<iostream>
#include<vector>
#include<stdlib.h>
using namespace std;

#include <bits/stdc++.h>
//#pragma GCC optimize("Ofast")
using namespace std;
#define endl "\n"
template<class T, class T2> bool chkmax(T &x, const T2 &y) {return (x < y) ? x = y, 1 : 0;}
template<class T, class T2> bool chkmin(T &x, const T2 &y) {return (x > y) ? x = y, 1 : 0;}
typedef long long ll;


//extern void init (std::vector <int> prices);
//extern int assumption (int day, int price);

vector<int> realPrices;

const int MAX_N = 1e3 + 10, MAX_PRICE = 1e3 + 10;

short delta[MAX_N][MAX_PRICE];
vector<pair<int, int> > row[MAX_N];
int ans = 0, where[MAX_N];
vector<pair<pair<int, int>, int> > intervals;
vector<int> toAdd[MAX_N], toRem[MAX_N];
int n;

short toAddLocal[MAX_PRICE][2], toRemLocal[MAX_PRICE][2];

void init(std::vector<int> prices) {
    n = prices.size();
    realPrices = prices;
    int cnt = 0;
    set<pair<int, int> > st;
    for(int i = 0; i < realPrices.size(); i ++) {
        realPrices[i] ++;
        if(st.upper_bound({realPrices[i], -1}) != st.end()) {
            where[i] = (*(st.upper_bound({realPrices[i], -1}))).second;
            st.erase(st.upper_bound({realPrices[i], -1}));
        } else {
            cnt ++;
            where[i] = ans ++;
            row[where[i]].push_back({MAX_PRICE - 1, -1});
        }
        row[where[i]].push_back({realPrices[i], i});
        st.insert({realPrices[i], where[i]});
    }
    for(int i = 0; i < ans; i ++) {
        row[i].push_back({0, n});
        for(int j = 1; j < row[i].size(); j ++) {
            intervals.push_back({{row[i][j].first + 1, row[i][j - 1].first}, 0});
            toAdd[row[i][j - 1].second + 1].push_back(intervals.size() - 1);
            toRem[row[i][j].second].push_back(intervals.size() - 1);
        }

        for(int j = 2; j < row[i].size(); j ++) {
            int price = 0;
            if(row[i].size() == 3) {
                price = 1;
            }
            intervals.push_back({{row[i][j].first + 1, row[i][j - 2].first}, price});
            toAdd[row[i][j - 1].second].push_back(intervals.size() - 1);
            toRem[row[i][j - 1].second + 1].push_back(intervals.size() - 1);
        }
    }

    for(int i = 0; i < n; i ++) {
        for(auto it : toAdd[i]) {
            toAddLocal[intervals[it].first.first][intervals[it].second] ++;
            toRemLocal[intervals[it].first.second][intervals[it].second] ++;
        }
        for(auto it : toRem[i]) {
            toAddLocal[intervals[it].first.first][intervals[it].second] --;
            toRemLocal[intervals[it].first.second][intervals[it].second] --;
        }
        int willEmpty = (row[where[i]].size() == 3);
        int cnt[2] = {0, 0};
        for(int j = 0; j < MAX_PRICE; j ++) {
            cnt[0] += toAddLocal[j][0] - toRemLocal[j][0];
            cnt[1] += toAddLocal[j][1] - toRemLocal[j][1];
            if(cnt[0] + cnt[1] > 0) {
                int ss;
                if(cnt[0]) {
                    ss = 0;
                } else {
                    ss = 1;
                }
                delta[i][j] = -willEmpty + ss;
            } else {
                delta[i][j] = 1;
            }
        }
    }
}

int assumption(int day, int price) {
    day --;
    price ++;
    return ans + delta[day][price];
}

