#include <bits/stdc++.h>
using namespace std;

const int maxn = 10004, maxm = 50004, maxq = 100005;
int n, m, q;
vector <pair <int, int> > adj [maxn];
bool taken [maxm], used [maxn];
int comp, changed;

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> m;
    for (int i = 1; i <= m; i ++){
        int u, v;
        cin >> u >> v;
        adj [u].push_back ({v, i});
        adj [v].push_back ({u, i});
    }
    for (int i = 1; i < n; i ++){
        int e;
        cin >> e;
        taken [e] = 1;
    }

    for (int i = 1; i <= n; i ++){
        if (used [i]) continue;
        used [i] = 1;
        comp ++;
        queue <int> q;
        q.push (i);
        while (!q.empty ()){
            int u = q.front ();
            q.pop ();
            for (auto p : adj [u]){
                if (!used [p.first] && !taken [p.second]){
                    used [p.first] = 1;
                    q.push (p.first);
                }
            }
        }
    }
    cout << n - comp << '\n';

    cin >> q;
    for (int i = 0; i < q; i ++){
        int x, y;
        cin >> x >> y;
        changed += taken [y] - taken [x];
        cout << n - comp - changed << '\n';
    }

}
