#include <bits/stdc++.h>
using namespace std;

const int maxn = 200005;
int n, m;
vector <int> adj [maxn];
int p [maxn], depth [maxn];
vector <vector <int> > groups;
int in_gr [maxn];
vector <int> idx_gr;
vector <pair <int, int> > queries, queries1 [maxn];
pair <int, int> ans = {0, maxn};
int r;

void comp_depth (int a){
    depth [a] = depth [p [a]] + 1;
    for (int i : adj [a]) comp_depth (i);
}

vector <int> hld_order;
int sz [maxn], hld_pos [maxn], chain_start [maxn];
set <int> pos_d [maxn];

void comp_sz (int a){
    sz [a] = 1;
    for (int i : adj [a]){
        comp_sz (i);
        sz [a] += sz [i];
    }
}
void build_hld (int a){
    hld_pos [a] = hld_order.size ();
    hld_order.push_back (a);
    int max_sz = 0, maxi = 0;
    for (int i : adj [a]){
        if (sz [i] > max_sz){
            max_sz = sz [i];
            maxi = i;
        }
    }
    if (maxi == 0) return;
    chain_start [maxi] = chain_start [a];
    build_hld (maxi);
    for (int i : adj [a]){
        if (i == maxi) continue;
        chain_start [i] = i;
        build_hld (i);
    }
}
void up_hld (int a, int d){
    if (a == 0) return;
    pos_d [d].insert (hld_pos [a]);
    up_hld (p [chain_start [a]], d);
}

int d_gr [maxn];
void dfs (int a){
    if (d_gr [depth [a]] != -1){
        in_gr [a] = d_gr [depth [a]];
        groups [d_gr [depth [a]]].push_back (a);
    }
    for (auto q : queries1 [a]){
        d_gr [q.first] = q.second;
    }
    for (int i : adj [a]) dfs (i);
    for (auto q : queries1 [a]){
        d_gr [q.first] = -1;
    }
}

int main (){

    //ios::sync_with_stdio (false);
    //cin.tie (0);

    cin >> n;
    for (int i = 2; i <= n; i ++){
        cin >> p [i];
        adj [p [i]].push_back (i);
    }
    comp_depth (1);
    comp_sz (1);
    build_hld (1);
    cin >> m;
    for (int i = 0; i < m; i ++){
        int u, k;
        cin >> u >> k;
        queries.push_back ({k, u});
    }
    sort (queries.begin (), queries.end ());
    for (auto q : queries){
        int k = q.first, u = q.second;
        int d = depth [u] + k;
        auto it = pos_d [d].lower_bound (hld_pos [u]);
        if (it != pos_d [d].end () && (*it) < hld_pos [u] + k) continue;
        queries1 [u].push_back ({d, groups.size ()});
        groups.push_back ({});
        up_hld (u, d);
    }

    for (int i = 1; i <= n; i ++) in_gr [i] = d_gr [i] = -1;
    dfs (1);
    int gr_sz = groups.size ();
    for (int i = 0; i < gr_sz; i ++){
        sort (groups [i].begin (), groups [i].end ());
        idx_gr.push_back (0);
        r = max (r, groups [i][0]);
    }
    for (int l = 1; l <= n; l ++){
        if (r - l < ans.second - ans.first){
            ans.first = l;
            ans.second = r;
        }
        if (in_gr [l] == -1) continue;
        idx_gr [in_gr [l]] ++;
        if (idx_gr [in_gr [l]] == groups [in_gr [l]].size ()){
            cout << ans.first << ' ' << ans.second << '\n';
            return 0;
        }
        r = max (r, groups [in_gr [l]][idx_gr [in_gr [l]]]);
    }
    cout << ans.first << ' ' << ans.second << '\n';

}
