#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")

using namespace std;

const int maxn = 1e4 + 3;

int n, m;
pair <int, int> edges[maxn * 5];
void read()
{
    cin >> n >> m;
    for (int i = 1; i <= m; i++)
        cin >> edges[i].first >> edges[i].second;
}

int par[maxn], sz[maxn];
int find_root(int ver)
{
    if (ver == par[ver])
        return ver;

    return par[ver] = find_root(par[ver]);
}

void merge(int a, int b)
{
    a = find_root(a), b = find_root(b);
    if (sz[a] < sz[b])
        swap(a, b);

    par[b] = a;
    sz[a] += sz[b];
}

void solve()
{
    set <int> s;
    for (int i = 1; i <= m; i++)
        s.insert(i);

    for (int i = 1; i <= n-1; i++)
    {
        int idx;
        cin >> idx;
        s.erase(idx);
    }

    int q;
    cin >> q;

    for (int i = 1; i <= n; i++)
        par[i] = i, sz[i] = 1;

    int ans = 0;
    for (auto i: s)
    if (find_root(edges[i].first) != find_root(edges[i].second))
    {
        ans++;
        merge(edges[i].first, edges[i].second);
    }

    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
