#include <iostream>
#include <assert.h>
#include <vector>
#include <set>

#ifdef LOCAL
#include "Lgrader.cpp"
#endif // LOCAL

using namespace std;

vector <int> prices;

void init (vector <int> _prices)
{
    prices = _prices;
}

int numCnt[1005];
vector <int> num2SeqsInds[1005];

int assumption (int day, int price)
{
    int _oldPrice = prices[day-1];
    prices[day-1] = price;

    vector <int> seqs;
    set <int> s;

    for(int x: prices)
    {
        int bestInd = -1;

        if(seqs.size()>50)
        {
            auto it = s.upper_bound(x);
            if(it!=s.end()) bestInd = num2SeqsInds[*it].back();
        }
        else
        {
            for(int i = 0;i<seqs.size();i++)
            {
                if(seqs[i]>x)
                {
                    if(bestInd==-1 || seqs[bestInd]>seqs[i])
                        bestInd = num2SeqsInds[seqs[i]].back();
                }
            }
        }

        if(bestInd!=-1)
        {
            numCnt[seqs[bestInd]]--;
            if(numCnt[seqs[bestInd]]==1) s.erase(x);
            num2SeqsInds[seqs[bestInd]].pop_back();

            seqs[bestInd] = x;

            numCnt[x]++;
            if(numCnt[x]==1) s.insert(x);
            num2SeqsInds[x].push_back(bestInd);
        }
        else
        {
            seqs.push_back(x);

            numCnt[x]++;
            if(numCnt[x]==1) s.insert(x);
            num2SeqsInds[x].push_back(seqs.size()-1);
        }
    }

    for(int x: seqs)
    {
        numCnt[x] = 0;
        num2SeqsInds[x].clear();
    }

    prices[day-1] = _oldPrice;
    return seqs.size();
}

/*
7
6 8 5 7 4 6 9
*/
