#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

vector<int> prices;
vector<bool> used;
vector<int> par;
vector<int> dp;

void init(vector<int> prices) {
    ::prices = prices;
    used.resize(prices.size());
    dp.resize(prices.size());
    par.resize(prices.size());
}

void eval() {
    fill(dp.begin(), dp.end(), 0);
    fill(par.begin(), par.end(), -1);

    for (int i = 0; i < (int)prices.size(); i++) {
        if (used[i]) {
            continue;
        }

        dp[i] = 1;

        for (int j = 0; j < i; j++) {
            if (!used[j] && prices[i] < prices[j]) {
                if (dp[j] + 1 > dp[i]) {
                    dp[i] = dp[j] + 1;
                    par[i] = j;
                }
            }
        }
    }
}

void markAsUsed(int pos) {
    while (pos != -1) {
        used[pos] = true;
        pos = par[pos];
    }
}

int assumption(int day, int price) {
    int origPrice = prices[day - 1];
    prices[day - 1] = price;

    fill(used.begin(), used.end(), false);

    int answer = 0;
    while (true) {
        eval();

            /*
        for (int i = 0; i < (int)prices.size(); i++) {
            cout << dp[i] << ' ';
        }
        cout << endl;
        for (int i = 0; i < (int)prices.size(); i++) {
            cout << used[i] << ' ';
        }
        cout << endl;
        */

        int mxIndex = 0;
        for (int i = 1; i < (int)prices.size(); i++) {
            if (dp[i] > dp[mxIndex]) {
                mxIndex = i;
            }
        }

        if (dp[mxIndex] == 0) {
            break;
        }

        answer++;
        markAsUsed(mxIndex);
    }

    prices[day - 1] = origPrice;

    return answer;
}

/*
6 8 5 7 4 6 9
*/
