#include<bits/stdc++.h>
using namespace std;

const int maxN = 1e3 + 1;
int n;
vector<int> pr;
bitset<maxN> used;

int prev;
int ans;
int query()
{
    used = 0;
    ans = 0;
    for(int i = 0; i < n; i++)
    {
        prev = i;
        if(!used[prev])
        {
            used[prev] = true;
            ans++;
            for(int j = i + 1; j < n; j++)
            {
                if(pr[j] < pr[prev])
                {
                    prev = j;
                    used[prev] = true;
                }
            }
        }
    }

    return ans;
}

void init (vector<int> prices)
{
    pr = prices;
    n = pr.size();
    dsu.resize(n);
    dsu[0] = pr[0];
    for(int i = 1; i < n; i++)
    {
        dsu[i] = max(dsu[i - 1], prices[i]);
    }
}

int assumption (int day, int price)
{
    day--;
    pr[day] = price;
    return query();
}
