#include<bits/stdc++.h>
using namespace std;

#define lowest(x) (x & -x)

int t1, t2, m1;
int mostSignificant(int x)
{
    x |= x >> 1;
    x |= x >> 2;
    x |= x >> 4;
    x |= x >> 8;
    x |= x >> 16;
    x++;
    x >>= 1;
    t1 = 0; t2 = 32;
    while(t1 < t2)
    {
        m1 = (t1 + t2) >> 1;
        if(x == (1 << m1)) return m1;
        if(x > (1 << m1)) t1 = m1 + 1;
        else t2 = m1;
    }

    return t1;
}

const int maxN = 2e6 + 1;
int n, m, c;
vector<int> p;
vector<vector<pair<int, int> > > sprs;
//*
pair<int, int> getAt(int pos, int level)
{
    pair<int, int> prev = sprs[pos][0];
    pair<int, int> next = {INT_MAX, INT_MIN};
    level--;
    if(level == 0) return prev;
    for(int step = mostSignificant(level); level > 0; step = mostSignificant(level), level -= (1 << step))
    {
        //cout <<"step " <<step <<" lvl " <<level <<endl;
        if(sprs[prev.first][step].first != INT_MAX)
        {
            next.first = min(next.first, sprs[prev.first][step].first);
            next.second = max(next.second, sprs[prev.first][step].second);
        }
        if(sprs[prev.second][step].first != INT_MAX)
        {
            next.first = min(next.first, sprs[prev.second][step].first);
            next.second = max(next.second, sprs[prev.second][step].second);
        }

        //cout <<"res -> ";
        //for(int w : res) cout <<w <<" "; cout <<endl;
        prev = next;
    }

    return next;
}
/*
void getAt(int pos, int level, vector<pair<int, int> > res)
{
    vector<pair<int, int>> prev = {sprs[pos][0]};
    level--;
    for(int step = mostSignificant(level); level > 0; step = mostSignificant(level), level -= (1 << step))
    {
        //cout <<"step " <<step <<" lvl " <<level <<endl;
        res.clear();
        for(auto& [a, b] : prev)
        {
            res.emplace_back(a);
            res.emplace_back(b);
        }

        //cout <<"res -> ";
        //for(int w : res) cout <<w <<" "; cout <<endl;
        prev = res;
    }
}
//*/
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    /*
    for(int i = 0; i < 100; i++)
    {
        cout <<i <<" -> " <<mostSignificant(i) <<endl;
    }
    //*/
    cin >>n;
    c = ceil(log2(n));
    p.assign(n, -1);
    for(int i = 1; i < n; i++)
    {
        cin >>p[i];
        p[i]--;
    }

    //for(int w : p) cout <<w <<" "; cout <<endl;
    //cout <<"T" <<endl;
    sprs.assign(n, vector<pair<int, int> >(c + 1, make_pair(INT_MAX, INT_MIN)));
    for(int i = 1; i < n; i++)
    {
        sprs[p[i]][0].first = min(sprs[p[i]][0].first, i);
        sprs[p[i]][0].second = max(sprs[p[i]][0].second, i);
    }

    for(int l = 1; l <= c; l++)
    {
        for(int i = 0; i < n; i++)
        {
            for(int w : {sprs[i][l - 1].first, sprs[i][l - 1].second})
            {
                if(w != INT_MIN && w != INT_MAX) sprs[i][l].first = min(sprs[i][l].first, sprs[w][l - 1].first);
                if(w != INT_MIN && w != INT_MAX) sprs[i][l].second = max(sprs[i][l].second, sprs[w][l - 1].second);
            }
        }
    }
    /*
    for(int i = 0; i < n; i++)
    {
        for(int l = 0; l <= c; l++)
        {
            cout <<"i " <<i + 1 <<" l " <<l <<" : ";
            cout <<sprs[i][l].first + 1 <<" -> " <<sprs[i][l].second + 1 <<endl;
        }
    }
    //*/
    cin >>m;
    int u, k;
    pair<int, int> ep;
    int mini = INT_MAX, maxi = INT_MIN;
    vector<pair<int, int>> res;
    while(m--)
    {
        cin >>u >>k;
        u--;
        ep = getAt(u, k);
        res.emplace_back(ep);
        //cout <<ep.first <<" -> " <<ep.second <<endl;
    }

    for(auto& w : res)
    {
        mini = min(mini, w.second);
        maxi = max(maxi, w.first);
    }

    cout <<mini + 1 <<" " <<maxi + 1 <<endl;
}
