#include<bits/stdc++.h>
using namespace std;

using vi = vector<int>;
using pii = pair<int, int>;
using ppp = pair<pii, pii>;
using vppp = vector<ppp>;
using vvppp = vector<vppp>;

#define lowest(x) (x & -x)
#define print(x) \
            (cout <<#x <<": ((" \
            <<x.first.first <<", " <<x.first.second <<"), (" \
            <<x.second.first <<", " <<x.second.second <<"))" <<endl);

int t1, t2, m1;
int mostSignificant(int x)
{
    x |= x >> 1;
    x |= x >> 2;
    x |= x >> 4;
    x |= x >> 8;
    x |= x >> 16;
    x++;
    x >>= 1;
    t1 = 0; t2 = 32;
    while(t1 < t2)
    {
        m1 = (t1 + t2) >> 1;
        if(x == (1 << m1)) return m1;
        if(x > (1 << m1)) t1 = m1 + 1;
        else t2 = m1;
    }

    return t1;
}

int n, m, c;
vi p;
vvppp sparse;
//*
ppp getAt(int pos, int level)
{
    ppp prev = sparse[pos][0];
    ppp next;
    level--;
    if(level == 0)
    {
        return prev;
    }
    for(int step = mostSignificant(level); level > 0; step = mostSignificant(level), level -= (1 << step))
    {
        //cout <<"step " <<step <<" lvl " <<level <<endl;
        //res.clear();
        next = {{INT_MAX, INT_MIN}, {INT_MAX, INT_MIN}};
        ppp&
            left = sparse[prev.first.first][step],
            right = sparse[prev.second.second][step];
        if(left.first.first < next.first.first)
        {
            next.first = left.first;
        }
        else if(left.second.first < next.first.first)
        {
            next.first = left.second;
        }
        else if(right.first.first < next.first.first)
        {
            next.first = right.first;
        }
        else if(right.second.first < right.first.first)
        {
            next.first = right.second;
        }

        if(right.second.second > next.second.second)
        {
            next.second = right.second;
        }
        else if(right.first.second > next.first.second)
        {
            next.second = right.first;
        }
        else if(left.second.second > next.second.second)
        {
            next.second = left.second;
        }
        else if(left.first.second > next.second.second)
        {
            next.second = left.first;
        }
        //if(pre)
        //cout <<"res -> ";
        //for(int w : res) cout <<w <<" "; cout <<endl;
        prev = next;
    }

    return prev;
}
//*/
int main()
{
    ios_base::sync_with_stdio(false);
    //cin.tie(NULL);

    cin >>n;
    c = ceil(log2(n));
    p.resize(n);
    sparse.assign(n, vppp(c + 1, ppp(pii(INT_MAX, INT_MIN), pii(INT_MAX, INT_MIN))));
    for(int i = 1; i < n; i++)
    {
        cin >>p[i];
        p[i]--;
        sparse[p[i]][0].first.first = min(sparse[p[i]][0].first.first, i);
        sparse[p[i]][0].first.second = max(sparse[p[i]][0].first.second, i);
    }
    for(int i = 0; i < n; i++)
    {
        sparse[i][0].second = sparse[i][0].first;
    }
    pii left, right;
    for(int l = 1; l <= c; l++)
    {
        for(int i = 0 ; i < n; i++)
        {
            left = sparse[i][l - 1].first;
            right = sparse[i][l - 1].second;
            if(left.first != INT_MAX)
            {
                sparse[i][l].first = sparse[left.first][l - 1].first;
                if(sparse[left.second][l - 1].first.first < sparse[i][l].first.first)
                {
                    sparse[i][l].first = sparse[left.second][l - 1].first;
                }
                else if(right.first != INT_MAX && sparse[right.first][l - 1].first.first < sparse[i][l].first.first)
                {
                    sparse[i][l].first = sparse[right.first][l - 1].first;
                }
                else if(right.first != INT_MAX && sparse[right.second][l - 1].first.first < sparse[i][l].first.first)
                {
                    sparse[i][l].first = sparse[right.second][l - 1].first;
                }

            }

            if(right.first != INT_MAX)
            {
                sparse[i][l].second = sparse[right.second][l - 1].second;
                if(sparse[right.first][l - 1].second.second > sparse[i][l].second.second)
                {
                    sparse[i][l].second = sparse[right.first][l - 1].second;
                }
                else if(left.first != INT_MAX && sparse[left.second][l - 1].second.second > sparse[i][l].second.second)
                {
                    sparse[i][l].second = sparse[left.second][l - 1].second;
                }
                else if(left.first != INT_MAX && sparse[left.first][l - 1].second.second > sparse[i][l].second.second)
                {
                    sparse[i][l].second = sparse[left.first][l - 1].second;
                }
            }

            if(sparse[i][l].first.first == INT_MAX &&
               sparse[i][l].second.first != INT_MAX)
            {
                sparse[i][l].second = sparse[i][l].first;
            }
            else if(sparse[i][l].first.first != INT_MAX &&
                    sparse[i][l].second.first == INT_MAX)
            {
                sparse[i][l].first = sparse[i][l].second;
            }
        }
    }
    /*
    for(int i = 0; i < n; i++)
    {
        for(int l = 0; l <= c; l++)
        {
            cout <<"i " <<i <<" l " <<l <<" ";
            print(sparse[i][l]);
        }
    }
    //*/
    cin >>m;
    int u, k;
    ppp ep;
    int mini = INT_MAX, maxi = INT_MIN;

    while(m--)
    {
        cin >>u >>k;
        u--;
        ep = getAt(u, k);
        //print(ep);
        if(ep.second.second < mini) mini = ep.second.second;
        if(ep.first.first > maxi) maxi = ep.first.first;
    }

    cout <<mini + 1 <<" " <<maxi + 1 <<endl;
}
/*
7
1 1 3 3 5 5
*/
