#include<bits/stdc++.h>
using namespace std;
const int MAXN=2e3+6;
const int MAXM=2e4+6;
struct dsu
{
    int par[MAXN];
    int sz[MAXN];
    void init()
    {
        for(int i=1;i<MAXN;i++)
        {
            par[i]=i;
            sz[i]=1;
        }
    }
    int getRoot(int u)
    {
        if(u==par[u])return u;
        return getRoot(par[u]);
    }
    void join(int p,int q)
    {
        if(sz[q]>sz[p])swap(p,q);
        par[q]=p;
        sz[p]+=sz[q];
    }
}ivan;
int u[MAXM],v[MAXM];
set<int>active;
set<int>not_active;
int n,m;
int query()
{
    ivan.init();
    int cnt=n;
    for(auto xd:not_active)
    {
        int p=ivan.getRoot(u[xd]);
        int q=ivan.getRoot(v[xd]);
        if(p==q)continue;
        //cout<<"* "<<u[xd]<<" "<<v[xd]<<endl;
        cnt--;
        ivan.join(p,q);
    }
    return n-cnt;
}
int main()
{
    cin>>n>>m;
    for(int i=1;i<=m;i++)cin>>u[i]>>v[i];
    for(int i=1;i<=m;i++)not_active.insert(i);
    for(int i=1;i<n;i++)
    {
        int t;
        cin>>t;
        active.insert(t);
        not_active.erase(t);
    }
    cout<<query()<<endl;
    int q;
    cin>>q;
    for(int i=0;i<q;i++)
    {
        int x,y;
        cin>>x>>y;
        active.insert(x);
        active.erase(y);
        not_active.erase(x);
        not_active.insert(y);
        cout<<query()<<endl;
    }
return 0;
}
/*
5 8
1 2
1 3
1 4
2 3
2 4
3 4
3 5
4 5
1 2 6 7
2
3 6
8 3
*/
