#include<iostream>
#include<vector>
#include<queue>
#include<stdlib.h>

using namespace std;
int p[20000],n;
void init (std::vector <int> prices)
{
    n=prices.size();
    for(int i=0;i<n;i++) p[i]=prices[i];
}
int assumption (int day, int price)
{
    queue<int> q;
    for(int i=0;i<n;i++)
    {
        if(i!=day-1) q.push(p[i]);
        else q.push(price);
    }
    int sz=n;
    int last;
    int cnt=0;
    while(!q.empty())
    {
        last=q.front();
        q.pop();
        sz=q.size();
        for(int i=0;i<sz;i++)
        {
            if(q.front()<last)
            {
                last=q.front();
                q.pop();
            }
            else
            {
                q.push(q.front());
                q.pop();
            }
        }
        cnt++;
    }
    return cnt;
}
int main () {
    int n;
    cin >> n ;
    vector <int> prices(n);
    for (int i=0; i<n; i++) {
        cin >> prices[i] ;
    }
    init(prices);

    int q,day,price;
    cin >> q ;
    for (int i=0; i<q; i++) {
        cin >> day >> price ;
        cout << assumption(day,price) << "\n";
    }
    return 0;
}
