#include<bits/stdc++.h>
using namespace std;

const int nmax=5e4+42;

int n,m;

pair<int,int> inp[nmax];

bool block[nmax];

int parent[nmax];

int root(int node)
{
    if(parent[node]==node)return node;
    parent[node]=root(parent[node]);
    return parent[node];
}
int solve()
{
    for(int i=1;i<=n;i++)parent[i]=i;

    int outp=0;

    for(int i=1;i<=m;i++)
        if(block[i]==0)
        {
            int u=inp[i].first;
            int v=inp[i].second;

            if(root(u)!=root(v))outp++;

            parent[root(u)]=root(v);
        }

    return outp;
}

int main()
{
    scanf("%i%i",&n,&m);

    for(int i=1;i<=m;i++)
        scanf("%i%i",&inp[i].first,&inp[i].second);

    for(int i=1;i<=n-1;i++)
    {
        int cur;
        scanf("%i",&cur);

        block[cur]=1;
    }

    printf("%i\n",solve());

    int q;
    scanf("%i",&q);

    for(int i=1;i<=q;i++)
    {
        int u,v;

        scanf("%i%i",&u,&v);

        block[u]=1;
        block[v]=0;

        printf("%i\n",solve());
    }

    return 0;
}