#include<bits/stdc++.h>
using namespace std;

const int nmax=2e5+42,inf=1e9;

int n;

vector<int> adj[nmax];

int in[nmax],out[nmax],t;
int depth[nmax];

vector<int> seen[nmax];

void dfs(int node,int d)
{
    seen[d].push_back(node);

    depth[node]=d;

    t++;

    in[node]=t;

    for(auto w:adj[node])
        dfs(w,d+1);

    out[node]=t;
}

vector< pair<int,int> > wanted[nmax];
bool cmp(pair<int,int> a,pair<int,int> b)
{
    if(a.first!=b.first)return a.first<b.first;

    return a.second>b.second;
}

int pref[nmax],suff[nmax];

int outp[nmax];

int tree[4*nmax];

void push(int node)
{
    tree[node*2]=max(tree[node],tree[node*2]);
    tree[node*2+1]=max(tree[node],tree[node*2+1]);

    tree[node]=0;
}
void update(int node,int l,int r,int lq,int rq,int val)
{
    if(l==lq&&r==rq)
    {
        tree[node]=max(tree[node],val);
        return;
    }

    push(node);

    int av=(l+r)/2;

    if(lq<=av)update(node*2,l,av,lq,min(av,rq),val);
    if(av<rq)update(node*2+1,av+1,r,max(av+1,lq),rq,val);
}

void make_update(int l,int r,int val)
{
    l=max(1,l);
    r=min(n,r);

    if(l>r)return;

    update(1,1,n,l,r,val);
}

int query(int node,int l,int r,int pos)
{
    if(l==r)return tree[node];

    push(node);

    int av=(l+r)/2;

    if(pos<=av)return query(node*2,l,av,pos);
    return query(node*2+1,av+1,r,pos);
}
int main()
{
    scanf("%i",&n);

    for(int i=1;i<=n;i++)outp[i]=i;

    for(int i=2;i<=n;i++)
    {
        int p;

        scanf("%i",&p);

        adj[p].push_back(i);
    }

    dfs(1,0);

    /*
    for(int i=0;i<=n;i++)
    {
        cout<<i<<" -> ";for(auto w:seen[i])cout<<w<<" ";cout<<endl;
    }
    */

    int q;

    scanf("%i",&q);

    for(int i=1;i<=q;i++)
    {
        int node,k;

        scanf("%i%i",&node,&k);

        int d_wanted=depth[node]+k;

        //cout<<"d_wanted= "<<d_wanted<<endl;

        int valid_l,valid_r;

        int ok=0,not_ok=seen[d_wanted].size();

        while(not_ok-ok>1)
        {
            int av=(ok+not_ok)/2;

            if(out[seen[d_wanted][av]]<=out[node])ok=av;
            else not_ok=av;
        }

        valid_r=ok;

        ok=seen[d_wanted].size()-1,not_ok=-1;

        while(ok-not_ok>1)
        {
            int av=(ok+not_ok)/2;

            if(in[seen[d_wanted][av]]>=in[node])ok=av;
            else not_ok=av;
        }

        valid_l=ok;

        //cout<<"valid_l= "<<valid_l<<" valid_r= "<<valid_r<<endl;

        wanted[d_wanted].push_back({valid_l,valid_r});
    }

    for(int i=0;i<=n;i++)
        if(wanted[i].size())
    {
        sort(wanted[i].begin(),wanted[i].end(),cmp);

        vector< pair<int,int> > help={};

        for(auto w:wanted[i])
        {
            while(help.size()&&help.back().second>=w.second)help.pop_back();

            help.push_back(w);
        }

        wanted[i]=help;

        for(auto w:wanted[i])
        {
            vector<int> me={};

            for(int p=w.first;p<=w.second;p++)
                me.push_back(seen[i][p]);

            sort(me.begin(),me.end());

            make_update(1,me[0],me[0]);
            /*
            for(int j=1;j<=me[0];j++)
                outp[j]=max(outp[j],me[0]);
            */

            for(int j=1;j<me.size();j++)
            {
                make_update(me[j-1]+1,me[j],me[j]);
                /*
                for(int v=me[j-1]+1;v<=me[j];v++)
                    outp[v]=max(outp[v],me[j]);
                */
            }

            make_update(me.back()+1,n,inf);
            /*
            for(int v=me.back()+1;v<=n;v++)
                outp[v]=max(outp[v],inf);
            */
        }

    }

    for(int i=1;i<=n;i++)
        outp[i]=max(outp[i],query(1,1,n,i));

    //cout<<"pref: ";for(int i=1;i<=n;i++)cout<<pref[i]<<" ";cout<<endl;
    //cout<<"suff: ";for(int i=1;i<=n;i++)cout<<suff[i]<<" ";cout<<endl;

    int l_outp=1,r_outp=n;

    for(int l=1;l<=n;l++)
    {
        int r=outp[l];

        if(r_outp-l_outp>r-l)
        {
            r_outp=r;
            l_outp=l;
        }
    }

    printf("%i %i\n",l_outp,r_outp);

    return 0;
}