// #include "Lgrader-crypto.cpp"
#include <vector>
using namespace std;

const int MAXN = 20004;

vector<int> p;
int val[MAXN], cnt = 0;
int orig = 0;

int assumption(int day, int price)
{
    cnt = 0;
    int old = p[day - 1];
    p[day - 1] = price;
    for (int i = 0; i < p.size(); ++ i)
    {
        int x = p[i];
        int l = 1, r = cnt, pos = 0;
        while (l <= r)
        {
            int mid = (l + r) / 2;
            if (val[mid] > x)
            {
                pos = mid;
                r = mid - 1;
            }
            else
            {
                l = mid + 1;
            }
        }

        //cout << "for " << i << " p[i] is " << p[i] << " ans " << pos << ' ' << val[pos] << endl;

        if (pos != 0) val[pos] = x;
        else
        {
            val[++cnt] = x;
        }
    }
    p[day - 1] = old;
    for (int i = 1; i <= cnt; ++ i) val[i] = 0;
    if (cnt < orig - 1 or cnt > orig + 1) while (orig);
    return cnt;
}

void init(vector<int> prices)
{
    p = prices;
    orig = assumption(1, p[0]);
}

