//#include "Lgrader-crypto.cpp"
#include <vector>
#include <set>
using namespace std;

const int MAXN = 2003;

vector<int> p;
int val[MAXN][MAXN];
int par[MAXN], suc[MAXN];
int cnt = 0, orig = 0;
int beg[MAXN];

int assumption(int day, int price)
{
    int l = 1, r = val[day - 1][0], pos = 0;
    if (day != 1)
    {
        while (l <= r)
        {
            int mid = (l + r) / 2;
            if (p[val[day - 2][mid]] > price)
            {
                pos = mid;
                r = mid - 1;
            }
            else
            {
                l = mid + 1;
            }
        }
    }

    if (par[day - 1] != -1 and suc[day - 1] != -1)
    {
        if (pos != 0)
        {
            int prev = val[day - 2][pos];
            if (suc[prev] == -1 or p[suc[prev]] < price) return orig;
            else return orig + 1;
        }
        if (pos == 0 and beg[day] != 0 and beg[day] < price) return orig - 1;
        else return orig;
    }
    if (par[day - 1] == -1 and suc[day - 1] != -1)
    {
        if (pos != 0)
        {
            int prev = val[day - 2][pos];
            if (suc[prev] == -1) return orig - 1;
            else return orig;
        }
        if (pos == 0 and beg[day] != 0 and beg[day] < price) return orig - 1;
        else return orig;
    }
    if (par[day - 1] != -1 and suc[day - 1] == -1)
    {
        if (pos != 0)
        {
            int prev = val[day - 2][pos];
            if (suc[prev] == -1) return orig - 1;
            else return orig;
        }
        if (pos == 0 and beg[day] != 0 and beg[day] < price) return orig - 1;
        else return orig;
    }
    if (par[day - 1] == -1 and suc[day - 1] != -1)
    {
        if (pos != 0)
        {
            int prev = val[day - 2][pos];
            if (suc[prev] == -1) return orig - 1;
            else return orig;
        }
        if (pos == 0 and beg[day] != 0 and beg[day] < price) return orig - 1;
        else return orig;
    }

    return 0;
}

void init(vector<int> prices)
{
    p = prices;

    for (int i = 0; i < p.size(); ++ i)
    {
        if (i != 0) // create new layer
        {
            for (int j = 0; j <= cnt; ++ j)
            {
                val[i][j] = val[i - 1][j];
            }
        }

        int l = 1, r = cnt, pos = 0;
        while (l <= r)
        {
            int mid = (l + r) / 2;
            if (p[val[i][mid]] > p[i])
            {
                pos = mid;
                r = mid - 1;
            }
            else
            {
                l = mid + 1;
            }
        }

        if (pos != 0)
        {
            par[i] = val[i][pos];
            suc[i] = -1;
            suc[val[i][pos]] = i;
            val[i][pos] = i;
        }
        else
        {
            val[i][++cnt] = i;
            suc[i] = -1;
            par[i] = -1;
            beg[i] = p[i];
        }
        val[i][0] = cnt;
    }

    int small = 1001;
    for (int i = p.size() - 1; i > 1; -- i)
    {
        if (beg[i] != 0) small = min(small, beg[i]);
        beg[i] = small;
    }

    orig = cnt;
}

