#include<bits/stdc++.h>
#define pb push_back
#define eb emplace_back
#define f first
#define s second
#define sz(x) ((int)x.size())
#define all(x) (x.begin(), x.end())

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

using ll = long long;
using ull = unsigned long long;
using namespace std;

const int MAXN = 2e5;
const int MAXM = 2e5;
int n, m;
vector<int> ch[MAXN];
int sz[MAXN];
int par[MAXN];
list<int> revqu[MAXN];
int l, r;

vector<vector<int>> un;
int h[MAXN];

struct comp {
    bool operator()(const pair<int, int>& l, const pair<int, int>& r) {
        return l.s < r.s;
    }
};

void input() {
    cin>>n;
    for (int i=0; i<n-1; i++) {
        cin>>par[i];
        par[i]--;
        ch[par[i]].pb(i+1);
    }

    int a, b;
    cin>>m;
    for (int i=0; i<m; i++) {
        cin>>a>>b;
        revqu[a-1].pb(b);
    }
}

void output() {
    cout<<l+1<<' '<<r+1<<endl;
}

int dfsCalc(int curr) {
    sz[curr] = 1;
    for (int i=0; i<ch[curr].size(); i++) {
        sz[curr] += dfsCalc(ch[curr][i]);
    }
    return sz[curr];
}

void dfs(int curr, int depth, set<int>& st) {
    int mx = 0, wh = -1;
    for (int i=0; i<ch[curr].size(); i++) {
        if (mx < sz[ch[curr][i]]) {
            wh = ch[curr][i];
            mx = sz[ch[curr][i]];
        }
    }

    if (wh != -1) {
        dfs(wh, depth+1, st);

        set<int> st2;
        for (int i=0; i<ch[curr].size(); i++) {
            if (ch[curr][i] != wh) {
                dfs(ch[curr][i], depth+1, st2);
                for (auto to : st2) {
                    st.insert(to);
                }
                st2.clear();
            }
        }
    }

    list<int>::iterator id =  revqu[curr].begin();
    while (id != revqu[curr].end()) {
        if (st.find(depth + (*id)) == st.end()) {
            st.insert(depth + (*id));
            id++;
        } else {
            auto id2 = id++;
            revqu[curr].erase(id2);
        }
    }
}

void dfs2(int curr, int depth) {
    if (h[depth] != -1) {
        un[h[depth]].pb(curr);
    }
    for (auto id : revqu[curr]) {
        h[id + depth] = un.size();
        un.eb();
    }
    for (auto to : ch[curr]) {
        dfs2(to, depth + 1);
    }
    for (auto id : revqu[curr]) {
        h[id + depth] = -1;
    }

}

int calcRight(int curr) {
    int cr = 0;
    for (int i=0; i<un.size(); i++) {
        cr = max(cr, (*lower_bound(un[i].begin(), un[i].end(), curr)));
    }
    return cr;
}

void solve() {
    dfsCalc(0);
    set<int> temp;
    dfs(0, 0, temp);

    /*for (int i=0; i<n; i++) {
        cerr<<i<<" : ";
        for (auto id : revqu[i]) {
            cerr<<id<<' ';
        }
        cerr<<endl;
    }*/

    for (int i=0; i<n; i++) {
        h[i] = -1;
    }
    dfs2(0, 0);
    /*for (int i=0; i<un.size(); i++) {
        for (auto to:un[i]) {
            cerr<<to<<' ';
        }
        cerr<<endl;
    }*/

    /*linijka

    l = un[0][0];
    r = un[0][0];
    for (int i=1; i<un.size(); i++) {
        l = min(l, un[i][0]);
        r = max(r, un[i][0]);
    }*/

    int dlim = MAXN, ulim = 0;
    for (int i=0; i<un.size(); i++) {
        int cmn = un[i][0], cmx = un[i][0];
        for (auto to : un[i]) {
            cmx = max(cmx, to);
            cmn = min(cmn, to);
        }
        dlim = min(dlim, cmx);
        ulim = max(ulim, cmn);
    }

    l = 0, r = n;
    for (int to = 0; to <= dlim; to++) {
        int cr = calcRight(to);
        if (cr == -1) {
            break;
        }
        if (cr - to < r - l) {
            l = to;
            r = cr;
        }
    }
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    input();
    solve();
    output();
    return 0;
}

/*
7
1 1 2 2 3 3
3
1 1
3 1
1 2

6
1 2 3 4 5
2
1 1
3 2

*/
