#include <bits/stdc++.h>
//#pragma GCC optimize("Ofast")
using namespace std;
#define endl "\n"
template<class T, class T2> bool chkmax(T &x, const T2 &y) {return (x < y) ? x = y, 1 : 0;}
template<class T, class T2> bool chkmin(T &x, const T2 &y) {return (x > y) ? x = y, 1 : 0;}
typedef long long ll;

const int MAX_N = 2e5 + 10;
int n, q;
vector<int> g[MAX_N];
pair<int, int> bfsord[MAX_N]; int cntBfs;
vector<pair<int, int> > inter;
vector<int> level[MAX_N];
int in[MAX_N], out[MAX_N], dist[MAX_N];
int tme = -1;
int levelStart[MAX_N];

void dfs(int x) {
    in[x] = ++ tme;
    for(auto it : g[x]) {
        dfs(it);
    }
    out[x] = tme;
}

void bfs(int x) {
    level[0] = {x};
    queue<pair<int, int> > q;
    q.push({x, 0});
    while(!q.empty()) {
        auto curr = q.front(); q.pop();
        dist[curr.first] = curr.second;
        bfsord[cntBfs] = {in[curr.first], curr.first}; cntBfs ++;
        for(auto it : g[curr.first]) {
            level[curr.second + 1].push_back(it);
            q.push({it, curr.second + 1});
        }
    }
    for(int i = 0; i < n; i ++) {
        levelStart[i] = 0;
        if(i != 0) {
            levelStart[i] = levelStart[i - 1] + level[i - 1].size();
        }
    }
}

vector<int> inWhich[MAX_N];
int currCnt[MAX_N], goodIntervals;

void addVert(int x) {
    for(auto it : inWhich[x]) {
        if(currCnt[it] == 0) {
            goodIntervals ++;
        }
        currCnt[it] ++;
    }
}

void remVert(int x) {
    for(auto it : inWhich[x]) {
        if(currCnt[it] == 1) {
            goodIntervals --;
        }
        currCnt[it] --;
    }
}

inline bool ok() {
    return inter.size() == goodIntervals;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cin >> n;
    for(int i = 2; i <= n; i ++) {
        int p;
        cin >> p;
        g[p].push_back(i);
    }
    dfs(1);
    bfs(1);
    cin >> q;
    auto cpy = inter;
    for(int i = 0; i < q; i ++) {
        int x, k;
        cin >> x >> k;
        //BAD?????
        int nowLevel = dist[x] + k;
        auto l = lower_bound(bfsord + levelStart[nowLevel], bfsord + levelStart[nowLevel + 1], make_pair(in [x], (int)1e9)) - bfsord;
        auto r = upper_bound(bfsord + levelStart[nowLevel], bfsord + levelStart[nowLevel + 1], make_pair(out[x], (int)1e9)) - bfsord - 1;
        cpy.push_back({l, -r});
    }
    sort(cpy.rbegin(), cpy.rend());
    int mx = MAX_N * 2;
    for(auto it : cpy) {
        if(mx <= -it.second && false) {
            continue;
        } else {
            mx = -it.second;
            inter.push_back({it.first, -it.second});
        }
    }
    for(int i = 0; i < inter.size(); i ++) {
        for(int j = inter[i].first; j <= inter[i].second; j ++) {
            inWhich[bfsord[j].second].push_back(i);
        }
    }

    int l = 1, r = 0;
    int L = 1, R = n;
    int ansLength = n;
    while(true) {
        while(r < n && !ok()) {
            addVert(r + 1); r ++;
        }
        if(r == n && !ok()) {
            break;
        }
        while(ok()) {
            if(chkmin(ansLength, r - l + 1)) {
                L = l;
                R = r;
            }
            remVert(l); l ++;
        }
    }
    cout << L << " " << R << endl;
}

