#include <bits/stdc++.h>
using namespace std;

const int maxn = 200005;
int n, m;
vector <int> adj [maxn];
int p [maxn];
vector <vector <int> > groups;
vector <int> in_groups [maxn];
vector <int> idx;
pair <int, int> ans = {0, maxn};
int r;

void dfs (int a, int k){
    if (k == 0){
        groups.back ().push_back (a);
        in_groups [a].push_back (groups.size () - 1);
        return;
    }
    for (int i : adj [a]) dfs (i, k - 1);
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n;
    for (int i = 2; i <= n; i ++){
        cin >> p [i];
        adj [p [i]].push_back (i);
    }
    cin >> m;
    for (int i = 0; i < m; i ++){
        int u, k;
        cin >> u >> k;
        groups.push_back ({});
        dfs (u, k);
        sort (groups.back ().begin (), groups.back ().end ());
        idx.push_back (0);
        r = max (r, groups.back () [0]);
    }
    for (int l = 1; l <= n; l ++){
        if (r - l < ans.second - ans.first){
            ans.first = l;
            ans.second = r;
        }
        for (int gr : in_groups [l]){
            idx [gr] ++;
            if (idx [gr] == groups [gr].size ()){
                cout << ans.first << ' ' << ans.second << '\n';
                return 0;
            }
            r = max (r, groups [gr][idx [gr]]);
        }
    }
    cout << ans.first << ' ' << ans.second << '\n';

}
