#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")

using namespace std;

const int maxn = 2e4 + 3;

int n;
int prices[maxn];
void init(vector <int> _prices)
{
    n = (int)_prices.size();
    for (int i = 1; i <= n; i++)
        prices[i] = _prices[i-1];
}

int r[maxn];
bool used[maxn];
int calc()
{
    stack <int> st;
    for (int i = n; i >= 1; i--)
    {
        while (!st.empty() && prices[st.top()] >= prices[i])
            st.pop();

        if (st.empty())
            r[i] = n + 1;

        else
            r[i] = st.top();

        st.push(i);
    }

    int ans = 0;
    for (int i = 1; i <= n; i++)
        if (!used[i])
    {
        ans++;
        int pos = i;
        while (!used[pos])
        {
            used[pos] = true;
            pos = r[pos];
        }
    }

    return ans;
}

int assumption(int day, int price)
{
    int prev = prices[day];
    prices[day] = price;
    int ans = calc();
    prices[day] = prev;

    return ans;
}
