#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")

using namespace std;

const int maxn = 2e4 + 3;
const int maxnum = 1003;

int n;
int prices[maxn];
int pr_dp[maxn][maxnum], su_dp[maxn][maxnum];
int without[maxn];
void init(vector <int> _prices)
{
    n = (int)_prices.size();
    for (int i = 1; i <= n; i++)
        prices[i] = _prices[i-1];

    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j < maxnum; j++)
            pr_dp[i][j] = pr_dp[i-1][j];

        int curr = pr_dp[i-1][prices[i]] + 1;
        for (int j = prices[i]; j < maxnum; j++)
            pr_dp[i][j] = max(pr_dp[i][j], curr);
    }

    for (int i = n; i >= 1; i--)
    {
        for (int j = 1; j < maxnum; j++)
            su_dp[i][j] = su_dp[i+1][j];

        int curr = su_dp[i+1][prices[i]] + 1;
        for (int j = prices[i]; j >= 1; j--)
            su_dp[i][j] = max(su_dp[i][j], curr);
    }

    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j < maxnum; j++)
            without[i] = max(without[i], pr_dp[i-1][j] + su_dp[i+1][j]);
    }
}

int assumption(int day, int price)
{
    int curr = without[day];
    curr = max(curr, pr_dp[day-1][price] + 1 + su_dp[day+1][price]);

    return curr;
}
