#include<vector>
#include<iostream>
using namespace std;

const int Max_N=200100;
const int Max_P=1010;

struct segm_tree{

    int  arr[4*Max_N];

    void clear_n(int n){
        for(int i=0;i<4*n;i++){
            arr[i]=0;
        }
        return;
    }

    void build(int i,int l,int r,int * or_arr){
        if(l==r){
            arr[i]=or_arr[l];
            return;
        }
        int m=(l+r)/2;
        build(2*i+1,l,m,or_arr);
        build(2*i+2,m+1,r,or_arr);
        arr[i]=max(arr[2*i+1],arr[2*i+2]);
        return;
    }

    int find_max(int i,int l,int r,int sl,int sr){
        //cout<<i<<" "<<l<<" "<<r<<" "<<sl<<" "<<sr<<endl;
        if(l==sl and r==sr){
            return arr[i];
        }
        int m=(l+r)/2;
        if(sr<(m+1)){
            return find_max(2*i+1,l,m,sl,sr);
        }
        if(m<sl){
            return find_max(2*i+2,m+1,r,sl,sr);
        }
        return max(find_max(2*i+1,l,m,sl,m),find_max(2*i+2,m+1,r,m+1,sr));
    }

    void upd_val(int i,int l,int r,int upd_i,int new_val){
        if(l==r){
            arr[i]=new_val;
            return;
        }
        int m=(l+r)/2;
        if(upd_i<m+1){
            upd_val(2*i+1,l,m,upd_i,new_val);
        }else{
            upd_val(2*i+2,m+1,r,upd_i,new_val);
        }
        arr[i]=max(arr[2*i+1],arr[2*i+2]);
        return;
    }

};

int n;
vector<int> pr;

int last_ed_ind=-1,val_bef_ch;


//vector<int> dp;
//
//int calc_long_incr_subseq(){
//    dp.resize(n);
//    dp[0]=1;
//    int big=0;
//    for(int i=1;i<n;i++){
//        big=0;
//        for(int j=0;j<i;j++){
//            if(pr[j]<=pr[i]){
//                big=max(big,dp[j]);
//            }
//        }
//        dp[i]=big+1;
//    }
//    int res=dp[0];
//    for(int i=0;i<n;i++){
//        res=max(res,dp[i]);
//    }
//    return res;
//}

segm_tree seg;

int calc_long_incr_subseq(){
    seg.clear_n(Max_P);
    for(int i=0;i<n;i++){
        seg.upd_val(0,0,Max_P-1,pr[i], seg.find_max(0,0,Max_P-1,0,pr[i])+1 );
    }
    return seg.find_max(0,0,Max_P-1,0,Max_P-1);
}

void init (std::vector <int> prices){
    pr=prices;
    n=pr.size();
//    calc_long_incr_subseq();
//    cout<<"Info : ";
//    for(int i=0;i<n;i++){
//        cout<<dp[i];
//    }
    return;
}

int assumption (int day, int price){
    if(last_ed_ind!=-1){
        pr[last_ed_ind]=val_bef_ch;
    }
    day--;
    last_ed_ind=day;
    val_bef_ch=pr[day];
    pr[day]=price;
    return calc_long_incr_subseq();
}
