#include<iostream>
#include<utility>
#include<algorithm>
#include<vector>
using namespace std;

const int Max_N=200200;
const int Max_log_N=25;
const int m_Inf=-999999;
const int Inf=999999;

int n,m;
int par [Max_N];

vector<int> graph [Max_N];

pair<int,int> q [Max_N];

void cin_data(){
    ios_base::sync_with_stdio(false);
    cin>>n;
    for(int i=1;i<n;i++){
        cin>>par[i];
        par[i]--;
        graph[par[i]].push_back(i);
    }
//    for(int i=0;i<n;i++){
//        cout<<"Index : "<<i<<endl;
//        for(int j=0;j<graph[i].size();j++){
//            cout<<graph[i][j]<<endl;
//        }
//    }
    par[0]=0;
    cin>>m;
    for(int i=0;i<m;i++){
        cin>>q[i].first>>q[i].second;
        q[i].first--;
    }
    return;
}

bool check_if_is_group_3(){
    for(int i=1;i<n;i++){
        if(par[i]!=(i-1)){
            return false;
        }
    }
    return true;
}

void calc_group_3(){
    int mi,ma;
    mi=Inf;
    ma=m_Inf;
    for(int i=0;i<m;i++){
        mi=min(mi, (q[i].first+q[i].second) );
        ma=max(ma, (q[i].first+q[i].second) );
    }
    cout<<mi+1<<" "<<ma+1;
    return;
}

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

//need to find min and max for k down

int depth [Max_N];

void dfs_calc_depth(int curr){
    for(int i=0;i<graph[curr].size();i++){
        depth[graph[curr][i]]=depth[curr]+1;
        dfs_calc_depth(graph[curr][i]);
    }
    return;
}

void calc_depth(){
    depth[0]=0;
    dfs_calc_depth(0);
//    for(int i=0;i<n;i++){
//        cout<<"Depth: index : "<<i<<" depth : "<<depth[i]<<endl;
//    }
    return;
}

vector<int> min_at [Max_N];
vector<int> max_at [Max_N];

int curr_calc_node;

void dfs(int curr){
    min_at[curr_calc_node][depth[curr]]=min(min_at[curr_calc_node][depth[curr]],curr);
    max_at[curr_calc_node][depth[curr]]=max(max_at[curr_calc_node][depth[curr]],curr);
    for(int i=0;i<graph[curr].size();i++){
        dfs(graph[curr][i]);
    }
    return;
}

void calc_min_max(){
    calc_depth();
    for(int i=0;i<n;i++){
        min_at[i].resize(n);
        max_at[i].resize(n);
        for(int j=0;j<n;j++){
            min_at[i][j]=Inf;
            max_at[i][j]=m_Inf;
        }
    }
    for(int i=0;i<n;i++){
        curr_calc_node=i;
        dfs(i);
    }
//    cout<<"Min data : "<<endl;
//    for(int i=0;i<n;i++){
//        cout<<"Node : "<<i<<endl;
//        for(int j=0;j<n;j++){
//            cout<<"At depth : "<<j<<" : "<<min_at[i][j]<<endl;
//        }
//    }
    return;
}

int find_min(int a,int b){
    return min_at[a][depth[a]+b];
}

int find_max(int a,int b){
    return max_at[a][depth[a]+b];
}

pair<int,int> ch [Max_N];

void calc(){
    calc_min_max();
    int sm_end=Inf,big_beg=m_Inf;
    for(int i=0;i<m;i++){
        sm_end=min( sm_end , find_max(q[i].first,q[i].second) );
        big_beg=max(big_beg, find_min(q[i].first,q[i].second) );
    }
    cout<<sm_end+1<<" "<<big_beg+1<<endl;
    return;
}

/*

7
1 1 2 2 3 3
3
1 1
3 1
1 2

3
1 2
2
1 2
1 1

*/

int main(){
    cin_data();
    if(check_if_is_group_3()){
        calc_group_3();
        return 0;
    }
    calc();
    //cout<<find_min(0,2);
    return 0;
}