#include<bits/stdc++.h>
#pragma optimize GCC OFast
using namespace std;
struct node {
    map<int, vector<int>> lookup; //lookup[1] - children
};
vector<node> V;
int n,m;
vector<int> p;
int localmin, localmax;
inline void addAll(vector<int>& to, vector<int>& from) {
    for(int &x : from) {
        to.push_back(x);
    }
}

void fetch(int curr) {
    for(int i = 1; i < n; i<<=1) {
        vector<int>& childrenAtI = V[curr].lookup[i];
        vector<int>& childrenAt2I = V[curr].lookup[i<<1];
        for(int child : childrenAtI) {
            addAll(childrenAt2I, V[child].lookup[i]);
        }
        if(childrenAt2I.size()==0) {
            break;
        }
    }
}
void processAll(int curr, int depth) {
    if(depth == 0) {
        localmin = min(localmin, curr);
        localmax = max(localmax, curr);
    }
    int toRemove = depth & -depth;
    depth -= toRemove;
    for(int child : V[curr].lookup[toRemove]) {
        processAll(child, depth);
    }
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n;
    V.resize(n);
    int u,v;
    for(int i = 0; i < n - 1; i++){
        cin>>u;
        u--;
        V[u].lookup[1].push_back(i+1);
    }
    for(int i = n - 1; i >= 0; i--) {
        fetch(i);
    }
    cin>>m;
    set<pair<int,int>> seen;
    int minOfMaxes = 200069;
    int maxOfMins = 0;
    for(int i = 0; i < m; i++) {
        cin>>u>>v;
        seen.insert({u,v});
        localmin = 200069;
        localmax = 0;
        processAll(u-1, v);
        minOfMaxes = min(minOfMaxes, localmax);
        maxOfMins = max(maxOfMins, localmin);
    }
    if(seen.size() == 1) {
        cout<<minOfMaxes+1<<" "<<minOfMaxes+1<<endl;
    }
    else {
        cout<<minOfMaxes+1<<" "<<maxOfMins+1<<endl;
    }
    return 0;
}

