#include<bits/stdc++.h>
#pragma optimize GCC OFast
using namespace std;
struct node {
    map<int, vector<int>> lookup; //lookup[1] - children
};
vector<node> V;
int n,m;
vector<int> p;
set<int> currSet;
set<int> allNumbers;
inline void addAll(vector<int>& to, vector<int>& from) {
    for(int &x : from) {
        to.push_back(x);
    }
}
int globalmin = 200069;
int globalmax = 0;
void fetch(int curr) {
    for(int i = 1; i < n; i<<=1) {
        vector<int>& childrenAtI = V[curr].lookup[i];
        vector<int>& childrenAt2I = V[curr].lookup[i<<1];
        for(int child : childrenAtI) {
            addAll(childrenAt2I, V[child].lookup[i]);
        }
        if(childrenAt2I.size()==0) {
            break;
        }
    }
}

void processAll(int curr, int depth) {
    if(depth == 0) {
        currSet.insert(curr);
        allNumbers.insert(curr);
    }
    int toRemove = depth & -depth;
    depth -= toRemove;
    for(int child : V[curr].lookup[toRemove]) {
        processAll(child, depth);
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n;
    V.resize(n);
    int u,v;
    for(int i = 0; i < n - 1; i++){
        cin>>u;
        u--;
        V[u].lookup[1].push_back(i+1);
    }
    for(int i = n - 1; i >= 0; i--) {
        fetch(i);
    }
    cin>>m;
    set<pair<int,int>> seen;
    vector<set<int>> sets;
    for(int i = 0; i < m; i++) {
        cin>>u>>v;
        if(seen.find({u,v}) != seen.end()) {
            continue;
        }
        seen.insert({u,v});
        currSet.clear();
        processAll(u-1, v);
        sets.push_back(currSet);
    }
    pair<int, int> res = {-1, -1};
    for(int start : allNumbers) {
        int finish = start;
        for(auto sett : sets) {
            auto bound = sett.lower_bound(start);
            if(bound == sett.end()) {
                cout<<res.first+1<<" "<<res.second+1<<endl;
                return 0;
            }
            if(*bound > finish) {
                finish = *bound;
            }
        }
        if(res.first == -1 or res.second - res.first > finish - start) {
            res = {start, finish};
        }
    }
    cout<<res.first+1<<" "<<res.second+1<<endl;
    return 0;
}
/**
8
1 2 3 1 5 3 5
2
1 2
3 1
*/
