#include <iostream>
#include <vector>

#ifdef LOCAL
#include "Lgrader.cpp"
#endif // LOCAL

using namespace std;

vector <int> prices;

void init (vector <int> _prices)
{
    prices = _prices;
}

int assumption (int day, int price)
{
    int _oldPrice = prices[day-1];
    prices[day-1] = price;

    vector <int> seqs;
    for(int x: prices)
    {
        int bestInd = -1;
        for(int i = 0;i<seqs.size();i++)
        {
            if(seqs[i]>x)
            {
                if(bestInd==-1 || seqs[bestInd]>seqs[i])
                    bestInd = i;
            }
        }

        if(bestInd!=-1) seqs[bestInd] = x;
        else seqs.push_back(x);
    }

    prices[day-1] = _oldPrice;
    return seqs.size();
}

/*
7
6 8 5 7 4 6 9
*/
