#include <iostream>
#include <vector>
#include <set>

#ifdef LOCAL
#include "Lgrader.cpp"
#endif // LOCAL

using namespace std;

vector <int> prices;

void init (vector <int> _prices)
{
    prices = _prices;
}

vector <int> num2SeqsInds[1005];
int assumption (int day, int price)
{
    int _oldPrice = prices[day-1];
    prices[day-1] = price;

    vector <int> seqs;
    multiset <int> ms;

    for(int x: prices)
    {
        int bestInd = -1;

        if(seqs.size()>40)
        {
            auto it = ms.upper_bound(x);
            if(it!=ms.end()) bestInd = num2SeqsInds[*it].back();
        }
        else
        {
            for(int i = 0;i<seqs.size();i++)
            {
                if(seqs[i]>x)
                {
                    if(bestInd==-1 || seqs[bestInd]>seqs[i])
                        bestInd = i;
                }
            }
        }


        if(bestInd!=-1)
        {
            ms.erase(ms.find(seqs[bestInd]));
            num2SeqsInds[seqs[bestInd]].pop_back();

            seqs[bestInd] = x;

            ms.insert(seqs[bestInd]);
            num2SeqsInds[seqs[bestInd]].push_back(bestInd);
        }
        else
        {
            seqs.push_back(x);

            ms.insert(x);
            num2SeqsInds[x].push_back(seqs.size()-1);
        }
    }

    for(int x: seqs)
    {
        num2SeqsInds[x].pop_back();
    }

    prices[day-1] = _oldPrice;
    return seqs.size();
}

/*
7
6 8 5 7 4 6 9
*/
