#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 1e5 + 5;

int deg[MAXN];

int main()
{
    int n, m;
    cin >> n >> m;

    vector <pair <int, int>> edges;
    for(int i = 0;i<m;i++)
    {
        int u, v;
        cin >> u >> v;

        edges.push_back({u, v});
    }

    for(int i = 0;i<n-1;i++)
    {
        int ind;
        cin >> ind;

        int u = edges[ind-1].first;
        int v = edges[ind-1].second;
        deg[u]++;
        deg[v]++;
    }

    bool hasAllEdges = false;
    for(int x = 1;x<=n;x++)
    {
        hasAllEdges |= (deg[x]==n-1);
    }

    cout << n - 1 - hasAllEdges << '\n';
}
