#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

vector<int> prices;
vector<int> dp;
int n;

void init(vector<int> prices) {
    ::prices = prices;
    n = prices.size();
    dp.resize(prices.size());
}

int assumption(int day, int price) {
    int origPrice = prices[day - 1];
    prices[day - 1] = price;

    map<int, int> tree;
    dp[n - 1] = 1;
    tree[prices[n - 1]] = 1;

    for (int i = n - 2; i >= 0; i--) {
        int to = -1, mx = 0;
        for (auto &j : tree) {
            if (prices[i] <= j.first) {
                break;
            }

            if (j.second > mx) {
                mx = j.second;
                to = j.first;
            }
        }

        dp[i] = mx + 1;

        tree[prices[i]] = max(tree[prices[i]], mx + 1);
        if (to != -1) {
            tree.erase(to);
        }
    }

    int answer = 0;
    for (int i = 0; i < n; i++) {
        if (dp[i] == 1) {
            answer++;
        }
    }

    prices[day - 1] = origPrice;

    return answer;
}

/*
6 8 5 7 4 6 9
*/
