# include <bits/stdc++.h>
using namespace std;
const int N = 1e5+5;
struct edge
{
    int u,v;
    int w;
};
edge g[N];
bool cmp(edge i, edge j)
{
    return i.w<j.w;
}
int group[N];
int sz[N];
int n,m;
int findgr(int v)
{
    if(group[v]==v)return v;
    group[v] = findgr(group[v]);
    return group[v];
}
void unite(int u, int v)
{
    u = findgr(u);
    v = findgr(v);
    if(sz[u]<sz[v])swap(u,v);
    group[v] = u;
}int ans = 0;
void solve()
{
    int i;
    for(i=1;i<=n;i++)
    {
        group[i]=i;
        sz[i] = 1;
    }

    for(i=1;i<=m;i++)
    {
        int u = g[i].u;
        int v = g[i].v;
        if(findgr(u)==findgr(v))continue;
        unite(u,v);
        if(g[i].w==0)ans++;
    }
    cout<<ans<<endl;

}
int main()
{

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>n>>m;
    for(int i=1;i<=m;i++)
    {
        cin>>g[i].u>>g[i].v;
        g[i].w = 0;
    }
    int k;
    for(int i=1;i<n;i++)
    {
        cin>>k;
        g[k].w = 1;
    }
    int q;
    cin>>q;
    sort(g+1,g+m+1,cmp);
    solve();
    int u,v;
    for(int i=1;i<=q;i++)
    {
        cin>>u>>v;
        if(g[u].w==0&&g[v].w==1)ans--;
        cout<<ans<<endl;
    }
    return 0;
}
