#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <limits.h>
#include <set>
#include <map>
#include <bitset>

using namespace std;

int n;
int m;
int p[3001];
int level[3001];
vector<int>onThatLevel[3001];
bitset<3001>matrix[3001];
bitset<3001>answers;

void solve()
{
	int L,R;
	int minLength=INT_MAX;
	for(int col=1;col<=n;col++)
	{	
		for(int i=0;i<m;i++)
		{
			answers[i]=matrix[i][col];
		}
		for(int col2=col;col2<=n;col2++)
		{
			bool ans=true;
			int tmp=0;
			for(int row=0;row<m;row++)
			{
				answers[row]=answers[row]|matrix[row][col2];
				if(!answers[row])ans=false;
			}
			if(ans)
			{
				if((col2-col)<minLength)
				{
					minLength=col2-col;
					L=col;
					R=col2;
				}
				break;
			}
		}
			
	}
	printf("%d %d\n",L,R);	
}

void init()
{
	scanf("%d",&n);
	level[1]=0;
	for(int i=2;i<=n;i++)
	{
		scanf("%d",&p[i]);
		level[i]=level[p[i]]+1;
		onThatLevel[level[i]].push_back(i);		
	}
	
	
	scanf("%d",&m);
	int u,k;
	for(int i=0;i<m;i++)
	{
		scanf("%d %d",&u,&k);
		int realLevel = level[u]+k;
		for(int j=0;j<onThatLevel[realLevel].size();j++)
		{
			int anc=onThatLevel[realLevel][j];
			for(int h=0;h<k;h++)
			{
				anc=p[anc];
			}
			if(anc==u)
			{
				matrix[i][onThatLevel[realLevel][j]]=1;	
			}
			
		}	
	}	
}

int main()
{
	init();
	solve();
	
}