#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <limits.h>
#include <set>
#include <map>
#include <bitset>

using namespace std;

int n;
int m;
int p[3001];
int level[3001];
vector<int>onThatLevel[3001];
bitset<3001>matrix[3001];
bitset<3001>answers;
bitset<3001>correctAnswer;
int dp[3001][3001];

void solve()
{
	if(n>3000)return;
	int L,R;
	int minLength=INT_MAX;
	for(int col=1;col<=n;col++)
	{	
		answers=matrix[col];
		for(int col2=col;col2<=n;col2++)
		{
			bool ans=true;
			int tmp=0;
			answers=answers|matrix[col2];
			if((answers^correctAnswer)==0)
			{
				if((col2-col)<minLength)
				{
					minLength=col2-col;
					L=col;
					R=col2;
				}
				break;
			}
		}
			
	}
	printf("%d %d\n",L,R);	
}

void init()
{
	
	for(int i=0;i<=n;i++)
	{
		dp[1][i]=0;
	}
	dp[1][0]=1;
	scanf("%d",&n);
	if(n<=3000)
	{
		level[1]=0;
		for(int i=2;i<=n;i++)
		{
			scanf("%d",&p[i]);
			level[i]=level[p[i]]+1;
			onThatLevel[level[i]].push_back(i);	
			dp[i][0]=i;
			for(int j=1;j<=n;j++)
			{
				dp[i][j]=dp[p[i]][j-1];	
			}	
		}
		
		
		scanf("%d",&m);
		for(int i=0;i<m;i++)
		{
			correctAnswer[i]=1;
		}
		int u,k;
		for(int i=0;i<m;i++)
		{
			scanf("%d %d",&u,&k);
			int realLevel = level[u]+k;
			for(int j=0;j<onThatLevel[realLevel].size();j++)
			{
				if(dp[onThatLevel[realLevel][j]][k]==u)
				{
					matrix[onThatLevel[realLevel][j]][i]=1;	
				}
				
			}	
		}
	}
	else
	{
		int pa;
		for(int i=2;i<=n;i++)
		{
			scanf("%d",&pa);		
		}
		
		
		scanf("%d",&m);
		int u,k;
		int L=INT_MAX,R=-1;
		for(int i=0;i<m;i++)
		{
			scanf("%d %d",&u,&k);
			L=min(L,u+k);
			R=max(R,u+k);	
		}
		printf("%d %d\n",L,R);
	}	
}

int main()
{
	init();
	solve();
	
}
